3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix
() {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?
*:/bin | ?
*:/usr
/bin
)
27 path
="$path$sep$SANE_TOOL_PATH"
50 if test -z "$GIT_QUIET"
56 if test -n "$OPTIONS_SPEC"; then
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra
="--keep-dashdash"
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
72 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
74 die
"Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
79 LONG_USAGE
="Usage: $dashless $USAGE"
81 LONG_USAGE
="Usage: $dashless $USAGE
87 -h|
--h|
--he|
--hel|
--help)
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
96 GIT_REFLOG_ACTION
="$*"
97 export GIT_REFLOG_ACTION
102 if test -z "${GIT_EDITOR:+set}"
104 GIT_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
107 eval "$GIT_EDITOR" '"$@"'
111 GREP_OPTIONS
= LC_ALL
=C
grep "$@"
115 GREP_OPTIONS
= LC_ALL
=C
egrep "$@"
118 is_bare_repository
() {
119 git rev-parse
--is-bare-repository
123 cdup
=$
(git rev-parse
--show-cdup)
126 # The "-P" option says to follow "physical" directory
127 # structure instead of following symbolic links. When cdup is
128 # "../", this means following the ".." entry in the current
129 # directory instead textually removing a symlink path element
130 # from the PWD shell variable. The "-P" behavior is more
131 # consistent with the C-style chdir used by most of Git.
133 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139 require_work_tree
() {
140 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
141 die
"fatal: $0 cannot be used without a working tree."
144 get_author_ident_from_commit
() {
147 s/'\''/'\''\\'\'\''/g
149 s/^author \([^<]*\) <[^>]*> .*$/\1/
151 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
154 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
156 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
159 s/^author [^<]* <[^>]*> \(.*\)$/\1/
161 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
166 encoding=$(git config i18n.commitencoding || echo UTF-8)
167 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
168 LANG=C LC_ALL=C sed -ne "$pick_author_script"
171 # Make sure we are in a valid repository of a vintage we understand,
172 # if we require to be in a git repository.
173 if test -z "$NONGIT_OK"
175 GIT_DIR=$(git rev-parse --git-dir) || exit
176 if [ -z "$SUBDIRECTORY_OK" ]
178 test -z "$(git rev-parse --show-cdup)" || {
180 echo >&2 "You need to run this command from the toplevel of the working tree."
184 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
185 echo >&2 "Unable to determine absolute path of git directory"
188 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
191 # Fix some commands on Windows
194 # Windows has its own (incompatible) sort and find